"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _got = require("got");

var _got2 = _interopRequireDefault(_got);

var _formData = require("form-data");

var _formData2 = _interopRequireDefault(_formData);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _class = function () {
  function _class(clientId, clientSecret, redirectUri, scope) {
    _classCallCheck(this, _class);

    this.clientId = clientId;
    this.clientSecret = clientSecret;
    this.redirectUri = redirectUri;
    this.scope = scope.join(" ");
    this.token = null; // Is set once auth() is called.
    this.baseUri = "https://api.23andme.com";
  }

  _createClass(_class, [{
    key: "auth",
    value: function auth(code) {
      var _this = this;

      var form = new _formData2.default();
      form.append("grant_type", "authorization_code");
      form.append("code", code);
      form.append("client_id", this.clientId);
      form.append("client_secret", this.clientSecret);
      form.append("redirect_uri", this.redirectUri);
      form.append("scope", this.scope);

      return (0, _got2.default)(this.baseUri + "/token", {
        method: "POST",
        headers: form.getHeaders(),
        body: form,
        json: true
      }).then(function (res) {
        return _this.token = res.body.access_token;
      });
    }
  }, {
    key: "user",
    value: function user() {
      return this.authedRequest("user");
    }
  }, {
    key: "names",
    value: function names() {
      return this.authedRequest("names");
    }
  }, {
    key: "haplogroups",
    value: function haplogroups() {
      return this.authedRequest("haplogroups");
    }
  }, {
    key: "ancestry",
    value: function ancestry() {
      return this.authedRequest("ancestry");
    }
  }, {
    key: "familyMembers",
    value: function familyMembers() {
      return this.authedRequest("family_members");
    }
  }, {
    key: "relatives",
    value: function relatives() {
      return this.authedRequest("relatives");
    }
  }, {
    key: "authedRequest",
    value: function authedRequest(path) {
      if (!this.token) {
        throw new Error("Failed to perform API request; no authorization token.");
      }

      return (0, _got2.default)(this.baseUri + "/1/" + path, {
        method: "GET",
        headers: { "Authorization": "Bearer " + this.token },
        json: true
      }).then(function (res) {
        return res.body;
      });
    }
  }, {
    key: "authUri",
    get: function get() {
      return this.baseUri + "/authorize?client_id=" + encodeURIComponent(this.clientId) + "&redirect_uri=" + encodeURIComponent(this.redirectUri) + "&scope=" + encodeURIComponent(this.scope) + "&response_type=code";
    }
  }]);

  return _class;
}();

exports.default = _class;